;***************  DDS *******************
  errorlevel 0, -302
; 
; RA0     - ELCD
; RA1     - A0LCD
; RB1     - CLK  AD
; RB2     - DATA AD
; RB3     - SYNC AD
; RB4-RB7 - Data LCD, 
; LCD
#define  PIN_ELCD   PORTA,0
#define  PIN_A0LCD  PORTA,1
; AD
#define  PIN_CLK    PORTB,1
#define  PIN_DATA   PORTB,2
#define  PIN_SYNC   PORTB,3

;  
BufLCD      equ 20H    ;   LCD
FreqMSB     equ 30H    ; 4b  
FreqMSB_OLD equ 34H    ; 4b  
PhaseMSB    equ 38H    ; 4b DDS

         cblock 3CH
;  
ARGA7
ARGA6
ARGA5
ARGA4
ARGA3
ARGA2
ARGA1
ARGA0

ARGB3
ARGB2
ARGB1
ARGB0

ARGC3
ARGC2
ARGC1
ARGC0

Cursor     ;  
Cursor_OLD
; 
COUNT1
COUNT2
COUNT3
TMP1

FLAG
;TimeBase
count_A
count_B
count_C
csa
cva
RTC        ;    2ms
GoSleep_LSB;    SLEEP
GoSleep    ; /

KN_new     ; .
KN_old     ;  .

         endc

         cblock 70H
;  
TmpInt1
TmpInt2
TmpInt3
         endc
; :
#define  BIT_0    FLAG,0  ; =1 -   
#define  BIT_FREQ FLAG,1  ; =1 - FREQ REG1
#define  BIT_GO   FLAG,2  ; =1 - AD  
#define  BIT_NS   FLAG,3  ; =1 -  T  nS

;  
UP       equ 00
DWN      equ 01
ENT      equ 02
ESC      equ 03

;============================================
;  
; Phase = [(Fout*10)*2^32]/[Ft*10]
; Tcek = [2^32*100]/[Ft*Phase]
; Ft -  ,
; Fout -  ,
; xxx.xxxxxx,x mkS ( nS_)
; xxx.xxxxxx,x Hz_
; ----------------------------------
; Ft = 20
; Phase = [(Fout*10)*2^32]/[1562500*2^7] =
;       = [(Fout*100)*2*2^24]/Kph
; T*0,1mks  = [2^32*10^6*10]/[Ft*Phase] =
;           = 2^31/Phase = 80000000H/Phase
; ----------------------------------
; Ft = 25
; Phase = [(Fout*10)*2^32]/[1953125*2^7] =
;       = [(Fout*10)*2*2^24]/Kph
; T*0,1mks  = [2^32*10^6*10]/[Ft*Phase] =
;           = [2^32*2/5]/Phase = 66666666H/Phase
; ----------------------------------
;   
; Ft = 20
; KT =2^31=80000000H    mks
;KT_3   equ  80H
;KT_2   equ  00H
;KT_1   equ  00H
;KT_0   equ  00H

; KTns =KT*1000 = 01F400000000    ns
;KTns_5   equ  01H
;KTns_4   equ  0F4H
;KTns_3   equ  00H
;KTns_2   equ  00H
;KTns_1   equ  00H
;KTns_0   equ  00H

; Kph =125*125*100=1562500=17D784H
;Kph_2  equ  17H
;Kph_1  equ  0D7H
;Kph_0  equ  84H
; Fmax = 80000000 = 04C4B400H
;Fmax_3 equ  004H
;Fmax_2 equ  0C4H
;Fmax_1 equ  0B4H
;Fmax_0 equ  000H
;
; Ft = 25
; KT =2^32*2/5=66666666H    mks
KT_3   equ  66H
KT_2   equ  66H
KT_1   equ  66H
KT_0   equ  66H

; KTns =KT*1000 = 018FFFFFFE70    ns
KTns_5   equ  01H
KTns_4   equ  8FH
KTns_3   equ  0FFH
KTns_2   equ  0FFH
KTns_1   equ  0FEH
KTns_0   equ  70H

; Kph =125*125*125=1953125=1DCD65H
Kph_2  equ  1DH
Kph_1  equ  0CDH
Kph_0  equ  65H
; Fmax = 110000000 = 068E7780H
Fmax_3 equ  006H
Fmax_2 equ  08EH
Fmax_1 equ  077H
Fmax_0 equ  080H

;    Sleep*512ms
CONSTSleep equ .6  ; 512*6=~3sec

        LIST    P=16F628A
        INCLUDE p16f628A.inc

;*********************   *****************
;  PIC16F628
; bit1-0   =01 (INTOSC) RA6 - CLKOUT
; bit4     =1  (INTOSC)
; bit2 - WDTE=0  (WDTE  disable)
; bit3 - PWRTE=0 (PWRTE enable)
; bit5     =1  (MCLR inable)
; bit6     =0  (BOD disable)
; bit7     =0  (LVP disable)
; bit8,13  =1  (Code protect off)

     __CONFIG  2131H     ; B'10.0001.0011.0001
;     __CONFIG  0131H     ; B'00.0001.0011.0001

          org    0000H
          goto   INIT
; 
          org    0004H
INTER:    movwf  TmpInt1       ; . W
          swapf  STATUS,W
          clrf   STATUS        ; 0 .
          movwf  TmpInt2       ; . STATUS
          btfss  INTCON,INTF
          goto   IntTmr0       ;  INT
          bcf    INTCON,INTF
;  Freq  
          movf   FreqMSB,W
          movwf  TmpInt3       ; 
          movlw  01            ; 
          call   WR01
          movf   FreqMSB+1,W
          movwf  TmpInt3       ; 
          movlw  02            ; 
          call   WR01
          movf   FreqMSB+2,W
          movwf  TmpInt3       ; 
          movlw  03            ; 
          call   WR01
          movf   FreqMSB+3,W
          movwf  TmpInt3       ; 
          movlw  04            ; 
          call   WR01
          movf   Cursor,W
          movwf  TmpInt3       ; 
          movlw  05            ; 
          call   WR01
IntTmr0:  btfss  INTCON,T0IF
          goto   IntEnd        ;  TMR0
          bcf    INTCON,T0IF
          incf   RTC,F         ;    2ms
          btfsc  STATUS,Z
          decf   RTC,F         ; =FF,  
          incf   GoSleep_LSB,F
          btfsc  STATUS,Z
          incf   GoSleep,F
          btfsc  STATUS,Z
          decf   GoSleep,F     ; =FF,  
;  
          bsf    STATUS,RP0
          movf   TRISB,W
          iorlw  0F0H
          movwf  TRISB         ; RB4-RB7 - IN
          bcf    STATUS,RP0
          comf   PORTB,W
          andlw  0F0H          ; . . =0
          movwf  csa
          swapf  csa,F         ; . . - . 
;    8
          MOVF   count_C,W
          XORWF  count_B,F
          XORWF  count_B,W
          ANDWF  count_C,W
          XORWF  count_A,F
          COMF   count_C,F
          MOVF   count_C,W
          ANDWF  count_A,W
          IORWF  count_B,F
          MOVF   csa,W
          XORWF  cva,W
          ANDWF  count_C,F
          ANDWF  count_B,F
          ANDWF  count_A,F
          MOVF   count_C,W
          IORWF  count_B,W
          IORWF  count_A,W
          ANDWF  cva,F
          XORLW  0xff
          ANDWF  csa,W
          IORWF  cva,F
          bsf    STATUS,RP0
          movf   TRISB,W
          andlw  00FH
          movwf  TRISB         ; RB4-RB7 - OUT
          bcf    STATUS,RP0
IntEnd:   swapf  TmpInt2,W
          movwf  STATUS        ; . STATUS
          swapf  TmpInt1,F
          swapf  TmpInt1,W     ; . W,   STATUS
          retfie

; /  DF 
; :  Cursor = 0...0F -  
; : ARGC3...ARGC0 - DF
LdDF:   movlw  .4              ; - 
        movwf  COUNT1
        movlw  ARGC3           ;  ARGC3
        movwf  FSR
        bcf    STATUS,C
        rlf    Cursor,W        ; Cursor*4
        movwf  TMP1
        rlf    TMP1,F
        movlw  LOW TabPKD+1    ; ..  . 
        addwf  TMP1,F          ; +   .
        clrf   PCLATH
LdTAB:  movf   TMP1,W
        call   TabPKD
        movwf  INDF
        incf   FSR,F
        incf   TMP1,F          ; .
        decfsz COUNT1,F
        goto   LdTAB
        return

;   DF
TabPKD: movwf  PCL
    DT  03BH,09AH,0CAH,000H    ; 1000000000 (_00.000000.0 xxx)
    DT  005H,0F5H,0E1H,000H    ; 100000000  (0_0.000000.0 xxx)
    DT  000H,098H,096H,080H    ; 10000000   (00_.000000.0 xxx)
    DT  000H,000H,000H,000H    ; 0          (000_000000.0 xxx)
    DT  000H,00FH,042H,040H    ; 1000000    (000._00000.0 xxx)
    DT  000H,001H,086H,0A0H    ; 100000     (000.0_0000.0 xxx)
    DT  000H,000H,027H,010H    ; 10000      (000.00_000.0 xxx)
    DT  000H,000H,003H,0E8H    ; 1000       (000.000_00.0 xxx)
    DT  000H,000H,000H,064H    ; 100        (000.0000_0.0 xxx)
    DT  000H,000H,000H,00AH    ; 10         (000.00000_.0 xxx)
    DT  000H,000H,000H,000H    ; 0          (000.000000_0 xxx)
    DT  000H,000H,000H,001H    ; 1          (000.000000._ xxx)
    DT  000H,000H,000H,000H    ; 0          (000.000000.0_xxx)
    DT  000H,000H,000H,000H    ; 0          (000.000000.0 _xx)
    DT  000H,000H,000H,000H    ; 0          (000.000000.0 x_x)
    DT  000H,000H,000H,000H    ; 0          (000.000000.0 xx_)
; (   100H)

; 
INIT:     clrf   STATUS
          clrf   PCLATH
          movlw  30H        ; 0011.0000 .. T0,INT
          movwf  INTCON
          clrf   T1CON      ;  TMR1,  1:1
          clrf   T2CON      ;  TMR2
          clrf   CCP1CON    ; CCP .
          clrf   PIR1
          clrf   RCSTA
          MOVLW  07H
          MOVWF  CMCON      ; . 
          MOVLW  00H
          MOVWF  PORTA
          movlw  0EH
          movwf  PORTB      ; 0000.1110 RB1,2,3=1 - AD9832
          bsf    STATUS,RP0 ; 1 
          MOVLW  0BCH       ; 1011.1100 RA0,1,6-OUT
          MOVWF  TRISA
          MOVLW  001H       ; 0000.0001
          MOVWF  TRISB      ; RB0 - IN
          movlw  02H        ; 0000.0010 1/8 TMR0, -| INT
          movwf  OPTION_REG
          clrf   PIE1       ;  .
          clrf   EECON1     ;  EEPROM PIC
          clrf   VRCON
          clrf   TXSTA      ; UART disable
          bcf    STATUS,RP0 ; 0 .
;
          clrf   FLAG
          call   LCDInit    ;  
          call   LCDclear   ;  
          call   InitAD     ;  AD9832
          clrf   FreqMSB_OLD
          clrf   FreqMSB_OLD+1
          clrf   FreqMSB_OLD+2
          clrf   FreqMSB_OLD+3
          clrf   Cursor_OLD
          clrf   cva
          clrf   KN_new
          clrf   KN_old
          clrf   RTC
          clrf   count_A
          clrf   count_B
          clrf   count_C
          clrf   GoSleep
          clrf   GoSleep_LSB
;    
          movlw  01
          call   RD01
          movwf  ARGB3
          movlw  02
          call   RD01
          movwf  ARGB2
          movlw  03
          call   RD01
          movwf  ARGB1
          movlw  04
          call   RD01
          movwf  ARGB0
          movlw  05
          call   RD01
          andlw  0FH         ; max 15
          movwf  Cursor
          movlw  .1          ; min Cursor-1
          subwf  Cursor,W    ; 1-Cursor
          movlw  .2
          btfss  STATUS,C    ; Cursor>1
          movwf  Cursor      ; <=1,  =2
          call   ChkOvf      ;   max
          movf   ARGB3,W
          movwf  FreqMSB
          movf   ARGB2,W
          movwf  FreqMSB+1
          movf   ARGB1,W
          movwf  FreqMSB+2
          movf   ARGB0,W
          movwf  FreqMSB+3
          clrf   TMR0
          bcf    INTCON,T0IF
          bcf    INTCON,INTF
          bsf    INTCON,GIE
;  
BEGIN:    movf   GoSleep,W
          sublw  CONSTSleep   ; CONSTSleep-W
          btfsc  STATUS,C     ; W>CONSTSleep
          goto   Beg02        ; W<=CONSTSleep,  
;   Sleep
          bcf    INTCON,GIE
          bsf    STATUS,RP0
          movf   TRISB,W
          iorlw  0F0H
          movwf  TRISB         ; RB4-RB7 - IN
          bcf    STATUS,RP0
          comf   PORTB,W
          andlw  0F0H          ; . . =0
          btfss  STATUS,Z      ;   
          goto   OutSleep      ; 
          bsf    INTCON,RBIE
          bcf    INTCON,RBIF   ;  
          sleep
;   Sleep
OutSleep: bsf    STATUS,RP0
          movf   TRISB,W
          andlw  00FH
          movwf  TRISB         ; RB4-RB7 - OUT
          bcf    STATUS,RP0
          clrf   GoSleep
          clrf   GoSleep_LSB
          bcf    INTCON,RBIE
          bsf    INTCON,GIE
;
Beg02:    movf   FreqMSB,W
          iorwf  FreqMSB+1,W
          iorwf  FreqMSB+2,W
          iorwf  FreqMSB+3,W
          btfsc  STATUS,Z
          incf   FreqMSB+3,F   ; F=0,  =00000001
          movf   FreqMSB_OLD,W
          xorwf  FreqMSB,W
          btfss  STATUS,Z
          goto   Beg01         ;  
          movf   FreqMSB_OLD+1,W
          xorwf  FreqMSB+1,W
          btfss  STATUS,Z
          goto   Beg01         ;  
          movf   FreqMSB_OLD+2,W
          xorwf  FreqMSB+2,W
          btfss  STATUS,Z
          goto   Beg01         ;  
          movf   FreqMSB_OLD+3,W
          xorwf  FreqMSB+3,W
          btfss  STATUS,Z
          goto   Beg01         ;  
          movf   Cursor,W
          xorwf  Cursor_OLD,W
          btfsc  STATUS,Z      ;  
          goto   KN01          ;  ,   
Beg01:    movf   FreqMSB,W     ;  F   
          movwf  FreqMSB_OLD
          movf   FreqMSB+1,W   ; /
          movwf  FreqMSB_OLD+1
          movf   FreqMSB+2,W   ; /
          movwf  FreqMSB_OLD+2
          movf   FreqMSB+3,W   ; /
          movwf  FreqMSB_OLD+3
          movf   Cursor,W
          movwf  Cursor_OLD
          call   CntPHT        ;  T  Phase
          call   TRN41         ;  T  2-10 
          call   BUF_T         ;   T
          call   Out1Str       ;   1 
          movf   FreqMSB,W
          movwf  ARGA3
          movf   FreqMSB+1,W
          movwf  ARGA2
          movf   FreqMSB+2,W
          movwf  ARGA1
          movf   FreqMSB+3,W
          movwf  ARGA0
          call   TRN41         ;  F  2-10 
          call   BUF_F         ;   F
          call   Out2Str       ;   2 
          movf   Cursor,W
          andlw  00FH          ; 0000.xxxx
          addlw  0C0H          ;   2- 
          call   LCDcom
          call   LdFreq        ;  Phase  AD
          btfss  BIT_GO        ; AD  
          call   PuskAD        ;  AD
          bsf    BIT_GO
; : . cva - 
KN01:     movf   cva,W
          movwf  KN_new      ;  . 
          btfss  STATUS,Z    ;  
          goto   KN03        ; 
          clrf   KN_old      ;  
          goto   BEGIN
KN03:     clrf   GoSleep
          clrf   GoSleep_LSB
          xorwf  KN_old,W
          btfss  STATUS,Z    ; .  
          goto   KN02        ; 
          movf   RTC,W
          sublw  .170        ; 170-RTC
          btfsc  STATUS,C    ;  340
          goto   KN01        ; 
KN02:     movf   KN_new,W    ;   . 
          movwf  KN_old
          clrf   RTC         ;  
          btfsc  KN_new,UP   ;   UP
          goto   PushUP
          btfsc  KN_new,DWN  ;   DWN
          goto   PushDWN
          btfsc  KN_new,ENT  ;   ENT
          goto   PushENT
          btfsc  KN_new,ESC  ;   ESC
          goto   PushESC
          goto   BEGIN
PushESC:  decf   Cursor,F
          comf   Cursor,W
          btfsc  STATUS,Z    ; Cursor <>0
          clrf   Cursor
          movlw  03
          xorwf  Cursor,W
          btfsc  STATUS,Z    ; Cursor <>3
          decf   Cursor,F    ; =3,  =2
          movlw  .10
          xorwf  Cursor,W
          btfsc  STATUS,Z    ; Cursor <>10
          decf   Cursor,F    ; =10,  =9
PsES1:    movlw  .2          ; min Cursor
          subwf  Cursor,W    ; Cursor-2
          movlw  .2
          btfss  STATUS,C    ; Cursor>=2
          movwf  Cursor      ; <2,  =2
          movf   Cursor,W
          andlw  0FH         ; max 15
          addlw  0C0H        ;   2- 
          call   LCDcom      ;  
          goto   BEGIN
PushENT:  incf   Cursor,F
          movlw  .12         ;  
          subwf  Cursor,W    ; Cursor-12
          btfsc  STATUS,C    ; Cursor<12
          decf   Cursor,F    ;  
          movlw  03
          xorwf  Cursor,W
          btfsc  STATUS,Z    ; Cursor <>3
          incf   Cursor,F    ; =3,  =4
          movlw  .10
          xorwf  Cursor,W
          btfsc  STATUS,Z    ; Cursor <>10
          incf   Cursor,F    ; =10,  =11
          goto   PsES1       ; 
PushDWN:  movf   FreqMSB,W   ; F
          movwf  ARGB3
          movf   FreqMSB+1,W ; /
          movwf  ARGB2
          movf   FreqMSB+2,W ; /
          movwf  ARGB1
          movf   FreqMSB+3,W ; /
          movwf  ARGB0
          call   LdDF        ;  DF
          call   SUB4 ; ARGB-ARGC-->ARGB  ARGB<ARGC, C=0
          btfss  STATUS,C
          goto   PushENT     ; F  ,  
PsDW1:    movf   ARGB3,W     ;  F
          movwf  FreqMSB
          movf   ARGB2,W     ; /
          movwf  FreqMSB+1
          movf   ARGB1,W     ; /
          movwf  FreqMSB+2
          movf   ARGB0,W     ; /
          movwf  FreqMSB+3
          goto   BEGIN
PushUP:   movf   FreqMSB,W   ; F
          movwf  ARGB3
          movf   FreqMSB+1,W ; /
          movwf  ARGB2
          movf   FreqMSB+2,W ; /
          movwf  ARGB1
          movf   FreqMSB+3,W ; /
          movwf  ARGB0
          call   LdDF        ;  DF
          call   ADD4  ; ARGB+ARGC-->ARGB, =1  
          btfsc  STATUS,C
          goto   PushENT     ; F  ,  
          call   ChkOvf      ;   
          goto   PsDW1

;==============================================

; /  Phase  T
; :  FreqMSB ... FreqMSB+3 = (Fout,)*10
; : PhaseMSB ... PhaseMSB+3 - DDS
;        ARGA3...ARGA0 - 
; Phase = [(Fout*10)*2*2^24]/Kph
CntPHT:   movf   FreqMSB,W
          movwf  ARGA6
          movf   FreqMSB+1,W
          movwf  ARGA5
          movf   FreqMSB+2,W
          movwf  ARGA4
          movf   FreqMSB+3,W
          movwf  ARGA3
          bcf    STATUS,C
          rlf    ARGA3,F     ; *2
          rlf    ARGA4,F
          rlf    ARGA5,F
          rlf    ARGA6,F
          clrf   ARGA2
          clrf   ARGA1
          clrf   ARGA0
          clrf   ARGB3       ; 
          movlw  Kph_2
          movwf  ARGB2
          movlw  Kph_1
          movwf  ARGB1
          movlw  Kph_0
          movwf  ARGB0
          call   CntPhAll    ;    
          movf   ARGA3,W     ;  Phase    
          movwf  ARGB3
          movwf  PhaseMSB
          movf   ARGA2,W
          movwf  ARGB2
          movwf  PhaseMSB+1
          movf   ARGA1,W
          movwf  ARGB1
          movwf  PhaseMSB+2
          movf   ARGA0,W
          movwf  ARGB0
          movwf  PhaseMSB+3
;  - nS  mkS
          bcf    BIT_NS      ;  mkS
          movf   PhaseMSB+1,W
          iorwf  PhaseMSB,W
          btfsc  STATUS,Z    ; Phase > 00.FF.FF.FF
          goto   CntPHmkS    ;   mkS
          bsf    BIT_NS      ;  nS
; T*1000 = (KTns_5...KTns_0)/Phase
          clrf   ARGA6
          movlw  KTns_5
          movwf  ARGA5
          movlw  KTns_4
          movwf  ARGA4
          movlw  KTns_3
          movwf  ARGA3
          movlw  KTns_2
          movwf  ARGA2
          movlw  KTns_1
          movwf  ARGA1
          movlw  KTns_0
          movwf  ARGA0
          goto   CntPhAll
; T*10 = (KT_3...KT_0)/Phase
CntPHmkS: clrf   ARGA6
          clrf   ARGA5
          clrf   ARGA4
          movlw  KT_3         ; KT   
          movwf  ARGA3
          movlw  KT_2
          movwf  ARGA2
          movlw  KT_1
          movwf  ARGA1
          movlw  KT_0
          movwf  ARGA0
CntPhAll: call   Div56by32
; 
; ARGA3-0 - 
; ARGB3-0 - 
; ARGC3-0 - 
          call   SUB4         ; ARGB-ARGC
          call   SUB4
          btfss  STATUS,C
          call   Inc4b        ; +1
          return

; /  7-    4- 
;: ARGA6-ARGA0 -   |:ARGA6-ARGA0  - 
;      .  .             |      .  .
;      ARGB3-ARGB0 -  |
;      COUNT1 -     |      ARGC3-ARGC0  - 
;: ARGA7

Div56by32:
; prepare used variables
        CLRF    ARGC3
        CLRF    ARGC2
        CLRF    ARGC1
        CLRF    ARGC0
        clrf    ARGA7
        MOVLW   D'56'           ; initialize bit counter
        MOVWF   COUNT1
Div5632Loop:
        RLF     ARGA0,F
        RLF     ARGA1,F
        RLF     ARGA2,F
        RLF     ARGA3,F
        RLF     ARGA4,F
        RLF     ARGA5,F
        RLF     ARGA6,F
; shift in highest bit from dividend through carry in temp
        RLF     ARGC0,F
        RLF     ARGC1,F
        RLF     ARGC2,F
        RLF     ARGC3,F
        rlf     ARGA7,F
        MOVF    ARGB0,W     ; get LSB of ARGB
        btfsc   ARGA7,7
        goto    Div5632Add
; subtract 32 bit ARGB from 32 bit ARGC
        SUBWF   ARGC0,F
        MOVF    ARGB1,W
        BTFSS   STATUS,C    ; if overflow ( from prev. subtraction )
        INCFSZ  ARGB1,W     ; incresase source
        SUBWF   ARGC1,F     ; and subtract from dest.
        MOVF    ARGB2,W
        BTFSS   STATUS,C    ; if overflow ( from prev. subtraction )
        INCFSZ  ARGB2,W     ; incresase source
        SUBWF   ARGC2,F     ; and subtract from dest.
        MOVF    ARGB3,W     ; get top byte
        BTFSS   STATUS,C    ; if overflow ( from prev. subtraction )
        INCFSZ  ARGB3,W     ; increase source
        SUBWF   ARGC3,F     ; and subtract from dest.
        movlw   1
        btfss   STATUS,C
        subwf   ARGA7,F
        GOTO    Div5632Skip ; continue with next bit
Div5632Add:
; result of subtraction was negative restore temp
        ADDWF   ARGC0,F     ; add it to the lsb of temp
        MOVF    ARGB1,W     ; middle byte
        BTFSC   STATUS,C    ; check carry for overflow from previous addition
        INCFSZ  ARGB1,W     ; if carry set we add 1 to the source
        ADDWF   ARGC1,F     ; add it to the lsb of temp
        MOVF    ARGB2,W     ; middle byte
        BTFSC   STATUS,C    ; check carry for overflow from previous addition
        INCFSZ  ARGB2,W     ; if carry set we add 1 to the source
        ADDWF   ARGC2,F     ; and add it if not zero in that case
        MOVF    ARGB3,W     ; MSB byte
        BTFSC   STATUS,C    ; check carry for overflow from previous addition
        INCFSZ  ARGB3,W
        ADDWF   ARGC3,F     ; handle overflow
        movlw   1
        BTFSC   STATUS,C
        addwf   ARGA7,F
Div5632Skip:
        DECFSZ  COUNT1,F    ; decrement loop counter
        GOTO    Div5632Loop ; another run
; finally shift in the last carry
        RLF     ARGA0,F
        RLF     ARGA1,F
        RLF     ARGA2,F
        RLF     ARGA3,F
        RLF     ARGA4,F
        RLF     ARGA5,F
        RLF     ARGA6,F
        RETURN              ; done

; / +1  7-  
; ARGA6-ARGA0 - 
Inc7b:    incf   ARGA0,F
          btfsc  STATUS,Z
          incf   ARGA1,F
          btfsc  STATUS,Z
          incf   ARGA2,F
          btfsc  STATUS,Z
          incf   ARGA3,F
          btfsc  STATUS,Z
          incf   ARGA4,F
          btfsc  STATUS,Z
          incf   ARGA5,F
          btfsc  STATUS,Z
          incf   ARGA6,F
          return

; / +1  4-  
; ARGA3-ARGA0 - 
Inc4b:    incf   ARGA0,F
          btfsc  STATUS,Z
          incf   ARGA1,F
          btfsc  STATUS,Z
          incf   ARGA2,F
          btfsc  STATUS,Z
          incf   ARGA3,F
          return

;/  4-  
;: ARGB3 - ARGB0 - 1- 
;      ARGC3 - ARGC0 - 2-  ( )
;:ARGB3 - ARGB0
;      .    .
;       1-  < 2-, C=0
SUB4:     MOVF   ARGC0,W   ; .  2- 
          SUBWF  ARGB0,F   ;  . 
          MOVF   ARGC1,W   ; . 2 
          BTFSS  STATUS,C
          INCFSZ ARGC1,W   ;   (=0)
          SUBWF  ARGB1,F   ;    (=1)
          MOVF   ARGC2,W
          BTFSS  STATUS,C
          INCFSZ ARGC2,W
          SUBWF  ARGB2,F
          MOVF   ARGC3,W
          BTFSS  STATUS,C
          INCFSZ ARGC3,W
          SUBWF  ARGB3,F   ;   =0
          RETURN

;/  4-  
;: ARGB3-ARGB0 - 1- 
;      ARGC3-ARGC0 - 2-  ( )
;:ARGB3-ARGB0 - , =1  
;      .    .
ADD4:     MOVF   ARGC0,W   ; .  2- 
          ADDWF  ARGB0,F   ;  . 
          MOVF   ARGC1,W   ; .  2- 
          BTFSC  STATUS,C
          INCFSZ ARGC1,W   ;  
          ADDWF  ARGB1,F   ;   
          MOVF   ARGC2,W
          BTFSC  STATUS,C
          INCFSZ ARGC2,W
          ADDWF  ARGB2,F
          MOVF   ARGC3,W
          BTFSC  STATUS,C
          INCFSZ ARGC3,W
          ADDWF  ARGB3,F
          RETURN

;/  4-    10
;: ARGA3-ARGA0 -    :ARGA3-ARGA0 - 
;      .  .                    .  .
;      COUNT1 -            TMP1  - 
DL410:    CLRF   TMP1       ;  .  
          MOVLW  20H        ; - .
          MOVWF  COUNT1     ;   
DL412:    CALL   SDV41      ;  4-    
          RLF    TMP1,F
          movlw  .10        ; -->W
          SUBWF  TMP1,W     ; ARGA4-W-->W,  , =0
          BTFSC  STATUS,C   ;  =0,  ()
          MOVWF  TMP1       ; 
          DECFSZ COUNT1,F   ;  
          GOTO   DL412      ;  32 
SDV41:    RLF    ARGA0,F    ;  4   1 .   . . 
          RLF    ARGA1,F
          RLF    ARGA2,F
          RLF    ARGA3,F
          RETURN

;/  4-    2-.  2-10 
;: ARGA3-ARGA0
;      .  .
;:BufLCD+6 - BufLCD+0F
;        .       .
;: COUNT1- .  
;        COUNT2-  
;        TMP1-   
TRN41:    BCF    STATUS,C; C=0
          MOVLW  0AH        ; -  -
          MOVWF  COUNT2     ;  
          MOVLW  BufLCD+0FH ; . . -
          MOVWF  FSR
TRN42:    CALL   DL410      ;   10
          MOVF   TMP1,W     ; -->W
          MOVWF  INDF
          DECF   FSR,F      ; FSR-1-->FSR
          DECFSZ COUNT2,F   ;  
          GOTO   TRN42
          RETURN

; /    Fmax
; ,: ARGB = F
ChkOvf:   movf   ARGB0,W    ; . F
          sublw  Fmax_0
          movf   ARGB1,W
          btfss  STATUS,C   ;  
          incfsz ARGB1,W
          sublw  Fmax_1
          movf   ARGB2,W
          btfss  STATUS,C
          incfsz ARGB2,W
          sublw  Fmax_2
          movf   ARGB3,W
          btfss  STATUS,C
          incfsz ARGB3,W
          sublw  Fmax_3     ;   C=0
          btfsc  STATUS,C   ;  
          return
          movlw  Fmax_0     ; F>Fmax,  =Fmax
          movwf  ARGB0
          movlw  Fmax_1
          movwf  ARGB1
          movlw  Fmax_2
          movwf  ARGB2
          movlw  Fmax_3
          movwf  ARGB3
          return

;**************** /    ****************
; /  LCD
; : COUNT1,TMP1,COUNT2
LCDInit:  clrw
          call   ZAD_Nms    ; 250ms
          movlw  03H
          movwf  TMP1
LCDIn1:   movlw  03H
          call   LCDcomIN   ;  3H, 3H, 3H
          movlw  .40
          call   ZAD_Nms    ; 40ms
          decfsz TMP1,F
          goto   LCDIn1
          movlw  02H        ;  4 
          call   LCDcomIN
          movlw  28H        ; /
          call   LCDcom
          movlw  08H
          call   LCDcom
          movlw  01H
          call   LCDcom
          movlw  .40
          call   ZAD_Nms
          movlw  06H
          call   LCDcom     ;   
          movlw  0EH
          call   LCDcom     ; . 
          return

; /    
; : ..W - 
; : COUNT1,COUNT2
LCDcomIN: bcf    PIN_A0LCD   ; A0=0, 
          andlw  0FH         ; 0000.xxxx
          movwf  COUNT1
          movf   PORTB,W
          andlw  0FH         ; 0000.xxxx.
          movwf  COUNT2      ; . . - . PB3-PB0
          swapf  COUNT1,W    ; xxxx.0000 -  
          iorwf  COUNT2,W    ; + . PB3-PB0
          movwf  PORTB       ; . 
          call   Enbl
          return

; /  
LCDclear: movlw  01
          call   LCDcom      ;  .
          movlw  .50
          call   ZAD_Nms     ; 50ms
          return

; /    LCD
; : W - 
; : COUNT1,COUNT2,COUNT3
LCDcom:   bcf    PIN_A0LCD   ; A0=0, 
          goto   LCDdat1

; /    LCD
; : W - 
; : COUNT1,COUNT2,COUNT3
LCDdata:  bsf    PIN_A0LCD   ; A0=1, 
LCDdat1:  movwf  COUNT1       ;  
          movf   PORTB,W
          andlw  0FH          ; 0000.xxxx.
          movwf  COUNT3       ; . . - . PB3-PB0
          movf   COUNT1,W
          andlw  0F0H         ; xxxx.0000
          iorwf  COUNT3,W     ; + PB3-PB0
          movwf  PORTB        ; . 
          call   Enbl
          swapf  COUNT1,W
          andlw  0F0H         ; xxxx.0000
          iorwf  COUNT3,W     ; + PB3-PB0
          movwf  PORTB        ; . 
          call   Enbl
          movf   COUNT1,W     ; . 
          return

; /   
; TMR0 - 
Enbl:     bsf    PIN_ELCD     ; E=1
          nop
          nop
          nop
          nop
          bcf    PIN_ELCD     ; E=0
          movf   TMR0,W
          movwf  COUNT2
Enl1:     movf   COUNT2,W
          subwf  TMR0,W       ; TMR0-COUNT2
          sublw  .5           ; 5-(TMR0-COUNT2)
          btfsc  STATUS,C     ; (TMR0-COUNT2)>=6,  >=6*8
          goto   Enl1         ;  50mks
          return

; /  
; : W - - ms
ZAD_Nms:  movwf  COUNT1
OUTTER:   movlw  .110
          movwf  COUNT2
INNER:    goto   $+1
          goto   $+1
          goto   $+1
          decfsz COUNT2,F
          goto   INNER      ; 110*9=990mks
          decfsz COUNT1,F
          goto   OUTTER
          return

; /      (1  2)
; : BufLCD -    16 .
; : FSR, TMP1,COUNT2,COUNT1
;  1- 
Out1Str:  movlw  080H       ;    1- 
          goto   OutStr01
;  2- 
Out2Str:  movlw  0C0H       ;    2- 
OutStr01: call   LCDcom
          movlw  06         ;   
          call   LCDcom
          movlw  BufLCD     ;  
          movwf  FSR
          movlw  .16
          movwf  TMP1       ;  
OutStr02: movf   INDF,W
          call   LCDdata    ;  
          incf   FSR,F
          decfsz TMP1,F
          goto   OutStr02   ; . 
          return

; /   LCD  T
; : BufLCD+6...BufLCD+0FH -   
;       Cursor = 0,,,0F -  
;       TMP1 -  . .
; : xxx.xxxxxx,x mkS,  BIT_NS=0
;        xxx.xxxxxx,x ns ,  BIT_NS=1 
BUF_T:    bcf    BIT_0
          movlw  00         ;   . 
          movwf  TMP1
          movlw  BufLCD+6   ;  . 
          movwf  FSR
          call   PrbIndBc
          movwf  BufLCD
          call   PrbIndBc
          movwf  BufLCD+1
          call   PrbIndBc
          movwf  BufLCD+2
          movlw  '.'
          btfss  BIT_0      ;   
          movlw  ' '        ; 
          movwf  BufLCD+3
          call   PrbIndBc
          movwf  BufLCD+4
          call   PrbIndBc
          movwf  BufLCD+5
          call   PrbIndBc
          movwf  BufLCD+6
          call   PrbIndBc
          movwf  BufLCD+7
          call   PrbIndBc
          movwf  BufLCD+8
          call   PrbInd0
          movwf  BufLCD+9
          movlw  ','
          movwf  BufLCD+.10
          call   PrbInd0
          movwf  BufLCD+.11
          movlw  ' '
          movwf  BufLCD+.12
          movlw  'm'
          btfsc  BIT_NS    ;  mkS
          movlw  'n'
          movwf  BufLCD+.13
          movlw  'k'
          btfsc  BIT_NS    ;  mkS
          movlw  'S'
          movwf  BufLCD+.14
          movlw  'S'
          btfsc  BIT_NS    ;  mkS
          movlw  ' '
          movwf  BufLCD+.15
          return

; /   LCD  F
; : BufLCD+6...BufLCD+0FH -   
;       Cursor = 0,,,0F -  
;       TMP1 -  . .
; : xxx.xxx.xxx,xHz_
BUF_F:    bcf    BIT_0
          movlw  00         ;   . 
          movwf  TMP1
          movlw  BufLCD+6   ;  . 
          movwf  FSR
          call   PrbIndCr
          movwf  BufLCD
          call   PrbIndCr
          movwf  BufLCD+1
          call   PrbIndCr
          movwf  BufLCD+2
          movlw  '.'
          btfss  BIT_0      ;   
          movlw  ' '        ; 
          incf   TMP1,F     ;  "."
          movwf  BufLCD+3
          call   PrbIndCr
          movwf  BufLCD+4
          call   PrbIndCr
          movwf  BufLCD+5
          call   PrbIndCr
          movwf  BufLCD+6
          call   PrbIndCr
          movwf  BufLCD+7
          call   PrbIndCr
          movwf  BufLCD+8
          call   PrbInd0
          movwf  BufLCD+9
          movlw  ','
          movwf  BufLCD+.10
          call   PrbInd0
          movwf  BufLCD+.11
          movlw  ' '
          movwf  BufLCD+.12
          movlw  'H'
          movwf  BufLCD+.13
          movlw  'z'
          movwf  BufLCD+.14
          movlw  ' '
          movwf  BufLCD+.15
          return

; /    
; : FSR -  
;       Cursor = 0,,,0F -  
; : BIT_0 -   
;        W - 
;   
PrbInd0:  movf   INDF,W
          goto   PrbIn01
;    
; TMP1 -  
PrbIndCr: movf   Cursor,W   ;  
          subwf  TMP1,W     ; TMP1-Cursor
          btfsc  STATUS,C   ; TMP1<Cursor
          bsf    BIT_0
          incf   TMP1,F
;   . 
PrbIndBc: movf   INDF,W
          btfss  STATUS,Z
          bsf    BIT_0      ;   
          btfsc  BIT_0      ; 
          goto   PrbIn01
          btfsc  STATUS,Z   ; <>0
          movlw  0F0H       ; =0,  
PrbIn01:  addlw  30H
          incf   FSR,F
          return

; *************** /  AD9832 ****************

; /  AD9832
; : FreqMSB ... FreqMSB+3 = (Fout,)*10
InitAD:   movlw  0F8H       ; F800 SLEEP=RESET=CLR=1
          call   LdByte
          movlw  00
          call   LdByte     ; /
          bsf    PIN_SYNC
          movlw  0B0H       ; B000 SYNC=SELSRC=1,  
          call   LdByte
          movlw  00
          call   LdByte     ; /
          movlw  18H        ; 1800 LOW PHASE0 --> Defer
          bsf    PIN_SYNC
          call   LdByte
          movlw  00
          call   LdByte     ; /
          bsf    PIN_SYNC
          movlw  09H        ; 0900 --> PHASE0
          call   LdByte
          movlw  00
          call   LdByte     ; /
          bsf    PIN_SYNC
          movlw  40H        ; 4000  PHASE0=00
          call   LdByte
          movlw  00
          call   LdByte     ; /
          bsf    PIN_SYNC
          return

; /  Freq AD9832
; : PhaseMSB...PhaseMSB+3
;       BIT_FREQ =1 - FREQ REG1
; : TMP1,COUNT1
LdFreq:   movlw  30H
          btfsc  BIT_FREQ   ; FreqREG0
          movlw  34H        ; FreqREG1
          call   LdByte
          movf   PhaseMSB+3,W ; L LSB -->DEFER
          call   LdByte
          bsf    PIN_SYNC
          movlw  21H
          btfsc  BIT_FREQ   ; FreqREG0
          movlw  25H        ; FreqREG1
          call   LdByte
          movf   PhaseMSB+2,W ; H LSB -->FREQx
          call   LdByte
          bsf    PIN_SYNC
          movlw  32H
          btfsc  BIT_FREQ   ; FreqREG0
          movlw  36H        ; FreqREG1
          call   LdByte
          movf   PhaseMSB+1,W ; L MSB -->DEFER
          call   LdByte
          bsf    PIN_SYNC
          movlw  23H
          btfsc  BIT_FREQ   ; FreqREG0
          movlw  27H        ; FreqREG1
          call   LdByte
          movf   PhaseMSB,W   ; H MSB -->FREQx
          call   LdByte
          bsf    PIN_SYNC
          movlw  50H
          btfsc  BIT_FREQ   ; FreqREG0
          movlw  58H        ; FreqREG1
          call   LdByte     ;  FreqREG
          clrw
          call   LdByte
          bsf    PIN_SYNC
          btfsc  BIT_FREQ   ;  BIT_FREQ
          goto   $+3
          bsf    BIT_FREQ   ;  0,  1
          return
          bcf    BIT_FREQ   ;  1,  0
          return

; /  AD9832
; : TMP1,COUNT1
PuskAD:   movlw  0C0H
          call   LdByte
          movlw  00
          call   LdByte
          bsf    PIN_SYNC
          return

; /    AD9832
; : W - 
; : TMP1,COUNT1
LdByte:   movwf  TMP1
          bsf    PIN_CLK
          movlw  .8
          movwf  COUNT1     ;  
          bcf    PIN_SYNC
LdBt01:   rlf    TMP1,F     ; MSB
          btfsc  STATUS,C
          bsf    PIN_DATA
          btfss  STATUS,C
          bcf    PIN_DATA
          nop
          bcf    PIN_CLK
          nop
          bsf    PIN_CLK
          decfsz COUNT1,F
          goto   LdBt01
          return

; ************* /   EEPROM *****************
; /   EEPROM
; : W - ,  0 .
; : W - 
RD01:   BSF      STATUS,RP0;    1- .
        MOVWF    EEADR;         
        BSF      EECON1,RD;     
        MOVF     EEDATA,W;      
        BCF      STATUS,RP0;    0 .
        RETURN

; / - . EEPROM
; : TmpInt3 - 
; W - 
; 0 ., . 
; 
WR01:   CALL     RD01          ; , W - 
        SUBWF    TmpInt3,W
        BTFSC    STATUS,Z      ;   
        RETURN                 ; , 
; 
        MOVF     TmpInt3,W
        BSF      STATUS,RP0    ; 1 .
        MOVWF    EEDATA        ;   
        BSF      EECON1,WREN   ; . 
        MOVLW    55H
        MOVWF    EECON2
        MOVLW    0AAH
        MOVWF    EECON2
        BSF      EECON1,WR     ;     
        BCF      STATUS,RP0    ; 0 .
        BTFSS    PIR1,EEIF     ; =1,  
        GOTO     $-1           ; . . 
        BCF      PIR1,EEIF     ;   . .
        BSF      STATUS,RP0    ; 1 .
        BCF      EECON1,WREN   ;  
        BCF      STATUS,RP0    ; 0 .
        RETURN

          end

